# Knative code samples

Find and use Knative code samples to help you get up and running with common use
cases. Code samples include content from the Knative team and community members.

Browse all code samples to find other languages and use cases that might align
closer with your goals.

### Knative owned and maintained

View the set of Knative code samples that are actively tested and maintained:

- [Eventing and Eventing Sources code samples](eventing.md)
- [Serving code samples](serving.md)

### Community owned and maintained

[View code samples that are contributed and maintained by the community](https://github.com/knative/docs/tree/main/code-samples/community).

### External code samples

A list of links to Knative code samples located outside of Knative repos:

- [Image processing using Knative Eventing, Cloud Run on GKE (Knative Serving implementation) and Google Cloud Vision API](https://github.com/akashrv/knative-samples/blob/master/docs/image-processing.md)
- [A potpourri of Knative Eventing Examples](https://github.com/lionelvillard/knative-examples)
- [Knfun - a complete Knative example of three functions using Twitter and Watson API that use kn to deploy and manage functions](https://github.com/maximilien/knfun)
- [Knative Eventing (Cloud Events) example using spring-boot and spring-cloud-streams + Kafka](https://salaboy.com/2020/02/20/getting-started-with-knative-2020/)
- [Image processing pipeline using Knative Eventing on GKE, Google Cloud Vision API and ImageSharp library](https://github.com/meteatamel/knative-tutorial/blob/master/docs/image-processing-pipeline.md)
- [BigQuery processing pipeline using Knative Eventing on GKE, Cloud Scheduler, BigQuery, mathplotlib and SendGrid](https://github.com/meteatamel/knative-tutorial/blob/master/docs/bigquery-processing-pipeline.md)
- [Performance (load) testing with SLO validation for Knative HTTP services](https://iter8.tools/0.8/tutorials/load-test-http/community/knative/loadtest/)
- [Performance (load) testing with SLO validation for Knative gRPC services](https://iter8.tools/0.8/tutorials/load-test-grpc/community/knative/loadtest/)

_Please add links to your externally hosted Knative code sample._
